import  java.io.*;
import  java.util.Scanner;


public class hashDoubleHashing {
 
    private static int size = 13;
    private static int offsetSize = size-1;
    private static int[] table;

// AUXILIARY METHODS

  public static int readInfo () {
    Scanner in = new Scanner(System.in);    
    System.out.print("Insert value: ");
    int info = in.nextInt();
    return info;
  }

    public static void printIndexes(int a[]) {
	int i;
	System.out.printf("\n-");
	for(i = 0; i < a.length; i++)
	    System.out.printf("%2d ",i);
	System.out.printf("----\n");
    }
 
    public static void printArray(int a[]) {
	int i;
	System.out.printf("[");
	for(i = 0; i < a.length; i++)
	    System.out.printf("%2d ",a[i]);
	System.out.printf("]\n");
    }

   public static int[] readArray() {
    Scanner in = new Scanner(System.in);    
    System.out.print("Length of the array: ");
    int size = in.nextInt();
    int[] a = new int[size];
    for (int i = 0; i < size; i++) {
       System.out.print("Insert the "+(i+1)+"-th value: ");
       a[i] = in.nextInt();
    }
    return a;   
   } 

// METHODS

    public static void init() {
	int i;
	table = new int[size];
	for(i = 0; i < table.length; i++)
	    table[i] = -1;
    }

    public static void print(int p) {
	int i;
        System.out.printf("[");
	for(i = 0; i < table.length; i++)
	    System.out.printf("%2d ",table[i]);
	System.out.println("] (probes: " + p + ")");
    }


    private static int probeHT(int k) {
      return (k % size );
    }

    private static int offsetHT(int k) {
        return 1+ (k % (offsetSize) );
	//	return (offsetSize) - (k % offsetSize );
    }

    public static int insert(int k) {
	int i = 0, pos;
        int probe = probeHT(k);
        int offset = offsetHT(k);
	while(i < table.length) {
	    pos = ((probe + i*offset) % size);
System.err.printf("   insert %2d in position %2d: ",k,pos);
	    if(table[pos] == -1 || table[pos] == -2) {
		table[pos] = k;
System.err.printf("done\n");
		return i;
	    }
	    else {
System.err.printf("collision!\n");
               i++;
	    }
	}
	return -1;
    }

    public static int search(int k) {
	int i = 0;
        int probe = probeHT(k);
        int offset =  offsetHT(k);
        int pos = probe;
	while(table[pos]!=k && table[pos]!= -1) {
System.err.printf("     searching %2d in position %2d\n",k,pos);
            i++;
	    pos = ((probe + i*offset) % size);
	}
	if(table[pos] == -1) {
System.err.printf("     %2d not found in position %2d\n",k,pos);
	  return -1;
	}
	else {
System.err.printf("     %2d found in position %2d\n",k,pos);
	    return pos;
        }
    }

    public static int delete(int k) {
	int i = 0;
        int probe = probeHT(k);
        int offset = offsetHT(k);
        int pos = probe;
	while(table[pos]!=k && table[pos]!= -1) {
System.err.printf("     searching %2d in position %2d\n",k,pos);
            i++;
	    pos = ((probe + i*offset) % size);
	}
	if(table[pos] == -1) {
System.err.printf("     %2d not found in position %2d\n",k,pos);
	  return -1;
	}
	else {
System.err.printf("     %2d found in position %2d\n",k,pos);
            table[pos]=-2;
	    return pos;
        }
    }

    public static void main(String args[]) {
      Scanner in = new Scanner(System.in);    
      int i, p, pos=-1;
      int key = 0;
      // example with size=11:
      // int[] a = {11,22,33,12,24,29,18,88,59};
      // example with size=13:
      int[] a = {13,26,39,14,28,33,20,41,95,78,67,99,42,57};
      String opt = null;
      char option = 'a';
      do {
	System.out.println();
	System.out.println("Insert the keys given below in a");
	System.out.println("hash table using open addressing");
	System.out.println(); System.out.print("Keys: ");
        printIndexes(a);        
        printArray(a);

	init();
        printIndexes(table);        
	for(i = 0; i < a.length; i++) {
	    p = insert(a[i]);
            if (p==-1)
	      System.err.printf("!!! The table is full!!!\n");
	    print(p);
	}
	System.out.println();
        do {
          printIndexes(table);  
          printArray(table);  
   	  System.out.println("Options:");
	  System.out.println(" i: insert new element");
	  System.out.println(" r: delete the element with given key");
	  System.out.println(" s: search the element with given key");
          opt = in.next(); option = opt.charAt(0);
          switch (option) {
	    case 'i': 
              key = readInfo();
              insert(key);
              if (pos==-1)
		  System.err.printf("The table is full\n");
		break;
	    case 's': 
              key = readInfo();
              pos=search(key);
              if (pos==-1)
                 System.out.printf("Not found\n");
              else
		  System.out.printf("Found in position %d\n",pos);
		break;
	    case 'r': 
              key = readInfo();
              pos=delete(key);
              if (pos==-1)
                 System.out.printf("Not found\n");
              else
		  System.out.printf("Found in position %d\n",pos);
		break;
	  }
	} while (
         option == 'i' || 
         option == 'r' || 
         option == 's' 
        );

	System.out.printf("Size of the new Hash Table: ");
        size = in.nextInt();
        a = readArray();
      } while (a.length>0);
    }
}

